// (c) Ter-Osipov Alex V. as known as Eraser on delphimaster.ru. 2009

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Dialogs, StdCtrls, ActiveX, ComCtrls, MMSystem, MMDeviceAPI;

type
  TfmMain = class(TForm)
    lbl1: TLabel;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
  private
    procedure GetInfo;
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}


procedure TfmMain.FormCreate(Sender: TObject);
begin
  //     .
  if (Win32Platform <> VER_PLATFORM_WIN32_NT) or (Win32MajorVersion < 6) then
  begin
    ShowMessage('For Vista and above only.');
    Application.Terminate;
  end;

  GetInfo;
end;

procedure TfmMain.GetInfo;
const
  PKEY_AudioEngine_DeviceFormat_GUID: TGUID = '{F19F064D-082C-4E27-BC73-6882A1BB8E4C}';
  PKEY_AudioEngine_DeviceFormat_pid = 0;
// DEFINE_PROPERTYKEY(PKEY_AudioEngine_DeviceFormat, 0xf19f064d, 0x82c, 0x4e27, 0xbc, 0x73, 0x68, 0x82, 0xa1, 0xbb, 0x8e, 0x4c, 0);
  STGM_READ = 0;
var
  FMMDevEnum: IMMDeviceEnumerator;
  FMMDev: IMMDevice;
  FEndPoint: IPropertyStore;
  Prop: tag_inner_PROPVARIANT;
  Key: _tagpropertykey;
  Format: TWaveFormatEx;
begin
  CoCreateInstance(CLASS_MMDeviceEnumerator, nil, CLSCTX_ALL, IID_IMMDeviceEnumerator, FMMDevEnum);

  FMMDevEnum.GetDefaultAudioEndpoint(eRender, eMultimedia, FMMDev);
  FMMDev.OpenPropertyStore(STGM_READ, FEndPoint);

  Key.fmtid := PKEY_AudioEngine_DeviceFormat_GUID;
  Key.pid := PKEY_AudioEngine_DeviceFormat_pid;

//  FillChar(Prop, SizeOf(Prop), 0);
  FEndPoint.GetValue(Key, Prop);
  Move(Prop.__MIDL____MIDL_itf_mmdeviceapi_0003_00810001.blob.pBlobData^, Format, SizeOf(Format));

  Edit1.Text := IntToStr(Format.nChannels);
  Edit2.Text := IntToStr(Format.nSamplesPerSec);
  Edit3.Text := IntToStr(Format.wBitsPerSample)
end;


{ TMyEndpointVolumeCallback }


end.
